// C Source File
// Created 1/22/2009; 1:47:38 PM

// Delete or comment out the items you do not need.

#define OptimizeRomCalls
#define COMMENT_PROGRAM_NAME   "petrowiz"
#define COMMENT_VERSION_NUMBER 1,2,23,56 /* major, minor, revision, subrevision */

// includes
	 
#include <tigcclib.h>

// Globals

float data[9], data_undo[9], normal_data[]={0,0,0,0,0};
int page[]={1,1};
int chart, displayed, current, move, last, data_in, data_input, chart_type, position, counter;
int undo, pos_set, in_help, data_good, type, change, modified, named, names_on;

// Functions

void draw_cursor(void)
{
	if(move == 1){DrawLine(25,12+(8*last)+(last-1), 53, 12+(8*last)+(last-1), A_REVERSE);};
	DrawLine(25,12+(8*position)+(position-1), 53, 12+(8*position)+(position-1), A_NORMAL);
	move=0;
}

void draw_box(void)
{
	DrawLine(25, 12+(8*position)+(position-1), 53, 12+(8*position)+(position-1), A_NORMAL);
	DrawLine(25, (12+(8*position)+(position-1))-8, 53, (12+(8*position)+(position-1))-8, A_NORMAL);
	DrawLine(25, 12+(8*position)+(position-1),25, (12+(8*position)+(position-1))-8, A_NORMAL);
	DrawLine(53, 12+(8*position)+(position-1),53, (12+(8*position)+(position-1))-8, A_NORMAL);
}

void erase_box(void)
{
	DrawLine(25, 12+(8*position)+(position-1), 53, 12+(8*position)+(position-1), A_REVERSE);
	DrawLine(25, (12+(8*position)+(position-1))-8, 53, (12+(8*position)+(position-1))-8, A_REVERSE);
	DrawLine(25, 12+(8*position)+(position-1),25, (12+(8*position)+(position-1))-8, A_REVERSE);
	DrawLine(53, 12+(8*position)+(position-1),53, (12+(8*position)+(position-1))-8, A_REVERSE);
}

//////////////////////////////////////////////////////////////////////////////////////////////
// Custom data entry routine makes everything run smoother //
/////////////////////////////////////////////////////////////

void enter_data(float value)
{
	if(data_in==0 && value!=10)
	{
		data_in=1;
		counter=0;
		data[position]=0;
	}
	else if((value==10 || value==0) && data_in==0)
	{
		data[position]=0;
		value=11;
	}
	if(data_in==1)
	{
		if(value!=10 && counter<3)
		{
			counter++;
			data_input=data[position];
			if(counter==1){data_input+=value;}
			if(counter>1){data_input=(data_input*10)+value;}
			data[position]=data_input;
			data_undo[counter]=value;
			data_undo[8]=counter;
			if(data[position]>100)
			{
				data[position]=100;
				data_undo[counter]=0;
			}
		}
		if(value==10 && data_in==1)
		{
			data_input=data[position];
			if(counter>1)
			{
				data_input=(data_input-data_undo[position])/10;
				data_undo[8]-=1;
				counter--;
			}
			else if(counter==1)
			{
				data_input=0;
				data_undo[8]=0;
				counter--;
			}
			data[position]=data_input;
		}
	}
	modified=1;
}

//////////////////////////////////////////////////////////////////////////////////////////////
// Draws the chart selected in the calculate routine //
///////////////////////////////////////////////////////

void draw_chart(void)
{
	switch ((int)chart_type)
	{
		case 1:
			DrawLine(57,99,108,1,A_NORMAL);
			DrawLine(108,1,159,99,A_NORMAL);
			DrawLine(57,99,159,99,A_NORMAL);
			DrawLine(103,10,113,10,A_NORMAL);
			DrawLine(88,40,128,40,A_NORMAL);
			DrawLine(67,80,149,80,A_NORMAL);
			DrawLine(59,95,157,95,A_NORMAL);
			DrawLine(67,99,92,40,A_NORMAL);
			DrawLine(92,99,95,80,A_NORMAL);
			DrawLine(122,99,114,40,A_NORMAL);
			DrawLine(147,99,124,40,A_NORMAL);
			break;
		case 2:
			DrawLine(57,99,108,1,A_NORMAL);
			DrawLine(108,1,159,99,A_NORMAL);
			DrawLine(57,99,159,99,A_NORMAL);
			DrawLine(103,10,113,10,A_NORMAL);
			DrawLine(64,95,108,10,A_NORMAL);
			DrawLine(152,95,108,10,A_NORMAL);
			DrawLine(62,90,67,99,A_NORMAL);
			DrawLine(154,90,149,99,A_NORMAL);
			DrawLine(82,60,134,60,A_NORMAL);
			DrawLine(64,95,152,95,A_NORMAL);
			break;
		case 3:
			DrawLine(57,1,108,99,A_NORMAL);
			DrawLine(108,99,159,1,A_NORMAL);
			DrawLine(57,1,159,1,A_NORMAL);
			DrawLine(62,10,154,10,A_NORMAL);
			DrawLine(88,60,128,60,A_NORMAL);
			DrawLine(67,1,92,60,A_NORMAL);
			DrawLine(147,1,124,60,A_NORMAL);
			DrawLine(92,1,93,10,A_NORMAL);
			DrawLine(122,1,121,10,A_NORMAL);
			DrawLine(108,10,108,60,A_NORMAL);
			break;
		case 4:
			DrawLine(57,99,108,1,A_NORMAL);
			DrawLine(108,1,159,99,A_NORMAL);
			DrawLine(57,99,159,99,A_NORMAL);
			DrawLine(59,95,157,95,A_NORMAL);
			DrawLine(103,10,113,10,A_NORMAL);
			DrawLine(108,10,64,95,A_NORMAL);
			DrawLine(108,10,152,95,A_NORMAL);
			break;
		case 5:
			DrawLine(57,99,108,1,A_NORMAL);
			DrawLine(108,1,159,99,A_NORMAL);
			DrawLine(57,99,159,99,A_NORMAL);
			DrawLine(88,40,128,40,A_NORMAL);
			DrawLine(67,80,149,80,A_NORMAL);
			DrawLine(92,99,95,80,A_NORMAL);
			DrawLine(122,99,114,40,A_NORMAL);
			break;
		case 6:
			DrawLine(57,1,108,99,A_NORMAL);
			DrawLine(108,99,159,1,A_NORMAL);
			DrawLine(57,1,159,1,A_NORMAL);
			DrawLine(62,10,154,10,A_NORMAL);
			DrawLine(88,60,128,60,A_NORMAL);
			DrawLine(92,1,93,10,A_NORMAL);
			DrawLine(122,1,121,10,A_NORMAL);
			DrawLine(108,10,108,60,A_NORMAL);
			break;
	}
	chart=1;
};

//////////////////////////////////////////////////////////////////////////////////////////////
// This is the meat of the program, it calculates the rocks' names //
/////////////////////////////////////////////////////////////////////

void calculate(void)
{
	// check the numbers and normalize if present or set error message	
	chart_type=0;
	
	////////////////////////////////////////////////////////////////////
	// Checks for 100% compositions //
	//////////////////////////////////
	
	if((data[1]==100 && (data[2]+data[3]+data[4]+data[5]+data[6]+data[7]+data[8])==0) || (data[2]==100 && (data[1]+data[3]+data[4]+data[5]+data[6]+data[7]+data[8])==0) || (data[3]==100 && (data[1]+data[2]+data[4]+data[5]+data[6]+data[7]+data[8])==0))
	{
		chart_type=1;
		data_good=1;
		normal_data[1]=100;
		if(data[1]==100)
		{
			normal_data[4]=1;
		}
		else if(data[2]==100)
		{
			normal_data[4]=2;
		}
		else if(data[3]==100)
		{
			normal_data[4]=3;
		}		
	}
	else if(data[4]==100 && (data[1]+data[2]+data[3]+data[5]+data[6]+data[7]+data[8])==0)
	{
		chart_type=3;
		data_good=1;
		normal_data[1]=100;
		normal_data[4]=4;
	}
	else if(data[5]==100 && (data[1]+data[2]+data[3]+data[4]+data[6]+data[7]+data[8])==0)
	{
		chart_type=4;
		data_good=1;
		normal_data[1]=100;
		normal_data[4]=5;
	}
	else if(data[8]==100 && (data[1]+data[2]+data[3]+data[4]+data[5]+data[6]+data[7])==0)
	{
		chart_type=2;
		data_good=1;
		normal_data[1]=100;
		normal_data[4]=8;
	}
	else if(data[6]==100 && (data[1]+data[2]+data[3]+data[4]+data[5]+data[8]+data[7])==0)
	{
		chart_type=2;
		data_good=1;
		normal_data[1]=100;
		normal_data[4]=6;
	}
	else if(data[7]==100 && (data[1]+data[2]+data[3]+data[4]+data[5]+data[6]+data[8])==0)
	{
		chart_type=2;
		data_good=1;
		normal_data[1]=100;
		normal_data[4]=7;
	}
	
	////////////////////////////////////////////////////////////////////
	// Checks for 3 and 2 way plots //
	//////////////////////////////////
	
	else if((data[2]+data[3]+data[4])>10 && data[1]==0)
	{
		normal_data[1]=data[3];
		normal_data[2]=data[2];
		normal_data[3]=data[4];		
		normal_data[4]=0;
		chart_type=3;
		data_good=1;
	}
	else if((data[1]+data[2]+data[3])>10 && data[4]==0)
	{
		normal_data[1]=data[3];
		normal_data[2]=data[2];
		normal_data[3]=data[1];
		normal_data[4]=0;	
		chart_type=1;
		data_good=1;
	}
	else if((data[5]+data[6]+data[7]+data[8])>90 && data[3]==0)
	{
		normal_data[1]=data[7];
		normal_data[2]=data[6];
		normal_data[3]=data[8];
		normal_data[4]=0;
		chart_type=2;
		data_good=1;
	}
	else
	{
		data_good=0;
	}
	if(data[3]>0 && data[1]==0 && data[4]==0 && (data[5]+data[6]+data[7]+data[8])>0)
	{
		normal_data[1]=data[8];
		normal_data[2]=data[5]+data[6]+data[7];
		normal_data[3]=data[3];
		normal_data[4]=0;
		chart_type=4;
		data_good=1;
	}
	if((data[1]+data[2]+data[3]+data[4]+data[5]+data[6]+data[7]+data[8])>100)
	{
		data_good=0;
	}
	if(type==2)
	{
		if(chart_type==1){chart_type=5;data_good=1;}
		if(chart_type==3){chart_type=6;data_good=1;}
	}	
	
	////////////////////////////////////////////////////////////////////	
	// Normalizes Data, this is what makes the whole thing work! //
	///////////////////////////////////////////////////////////////
	
	float y=0,z=0;
	z=(normal_data[1]+normal_data[2]+normal_data[3]);
	y=100/z;
	normal_data[1]=normal_data[1]*y;
	normal_data[2]=normal_data[2]*y;
	normal_data[3]=normal_data[3]*y;
	
	////////////////////////////////////////////////////////////////////
	
}

//////////////////////////////////////////////////////////////////////////////////////////////
// Calculates and plots rocks on the proper chart //
////////////////////////////////////////////////////

void draw_pos(void)
{
	if(normal_data[4]==0)
	{
		///////////////////////////////////////////////////////////////////////////////////////////////
		// (216 + (a+normal_data[b]))/2 calculates the x at which the chart boundary is at a given y //
		///////////////////////////////////////////////////////////////////////////////////////////////
		if(chart_type==1 || chart_type==4 || chart_type==2 || chart_type==5)
		{
			DrawLine(57+normal_data[1],99,((216+normal_data[1])/2),normal_data[1],A_THICK1);
			DrawLine(159-normal_data[2],99,((216-normal_data[2])/2),normal_data[2],A_THICK1);
			DrawLine(((216-(99-normal_data[3]))/2),99-normal_data[3],((216+(99-normal_data[3]))/2),99-normal_data[3],A_THICK1);			
		}
		else if(chart_type==3 || chart_type==6)
		{
			DrawLine(57+normal_data[1],1,((216+normal_data[1])/2),99-normal_data[1],A_THICK1);
			DrawLine(159-normal_data[2],1,((216-normal_data[2])/2),99-normal_data[2],A_THICK1);
			DrawLine(((216-(99-normal_data[3]))/2),1+normal_data[3],((216+(99-normal_data[3]))/2),1+normal_data[3],A_THICK1);
		}				
	}
	else if(normal_data[4]!=0)
	{
		switch((int)normal_data[4])
		{
			case 1:
				DrawLine(57,98,108,1,A_THICK1);
				DrawLine(159,98,108,1,A_THICK1);
				break;
			case 2:
				DrawLine(57,98,108,1,A_THICK1);
				DrawLine(57,98,159,98,A_THICK1);
				break;
			case 3:
				DrawLine(108,1,159,98,A_THICK1);
				DrawLine(57,98,159,98,A_THICK1);
				break;
			case 4:
				DrawLine(57,1,108,98,A_THICK1);
				DrawLine(108,98,159,1,A_THICK1);
				break;
			case 5:
				DrawLine(57,99,108,1,A_THICK1);
				DrawLine(159,98,57,98,A_THICK1);
				break;
			case 6:
				DrawLine(57,98,108,1,A_THICK1);
				DrawLine(159,98,57,98,A_THICK1);
				break;
			case 7:
				DrawLine(57,98,159,98,A_THICK1);
				DrawLine(108,1,159,98,A_THICK1);
				break;
			case 8:
				DrawLine(57,98,108,1,A_THICK1);
				DrawLine(159,98,108,1,A_THICK1);
				break;			
		}
	}
	modified=1;
	pos_set=1;
}

//////////////////////////////////////////////////////////////////////////////////////////////
// Erases the plot window //
////////////////////////////

void clearit(void)
{
	char y=1;
	for(y=1;y<99;y++)
	{
		DrawLine(58,y,158,y,A_REVERSE);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////
// Erases the data window //
////////////////////////////

void clearleft(void)
{
	char y=1;
	for(y=1;y<99;y++)
	{
		DrawLine(1,y,((216+y)/2),y,A_REVERSE);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////
// Plots the names of the rocks //
//////////////////////////////////

void draw_names(void)
{
	FontSetSys(F_4x6);
	switch((int)chart_type)
	{
		case 1:
			page[1]=2;
			printf_xy(106,4,"1");
			printf_xy(106,20,"2");
			printf_xy(76,60," 3       4           5    6");
			printf_xy(60,86,"   7      8         9         10     11");
			printf_xy(60,94,"12    13         14          15     16");
			switch(page[0])
			{
				case 1:
					printf_xy(3,3,"1: Quartz");
					printf_xy(3,11,"2: Quartz-Rich Granitoid");
					printf_xy(3,19,"3: Alkali-Feldspar Granite");
					printf_xy(3,27,"4: Granite");
					printf_xy(3,35,"5: Granodiorite");
					printf_xy(3,43,"6: Tonalite");
					printf_xy(3,51,"7: Alkali-Feldspar");
					printf_xy(11,59,"Quartz Syenite");
					printf_xy(3,67,"8: Quartz Syenite");
					printf_xy(3,75,"9: Quartz");
					printf_xy(11,83,"Monzonite");
					printf_xy(3,91,"<MORE>");
					break;
				case 2:
					printf_xy(3,3,"<MORE>");
					printf_xy(3,11,"10: Quartz Monzodiorite");
					printf_xy(3,19,"11: Quartz Diorite/Gabbro");
					printf_xy(3,27,"12: Alkali-Feldspar");
					printf_xy(11,35,"Syenite");
					printf_xy(3,43,"13: Syenite");
					printf_xy(3,51,"14: Monzonite");
					printf_xy(3,59,"15: Monzodiorite");
					printf_xy(3,67,"16: Diorite/");
					printf_xy(11,75,"Gabbro/");
					printf_xy(11,83,"Anorthosite");
					break;
			}
			break;
		case 2:
			page[1]=1;
			printf_xy(106,4,"1");
			printf_xy(85,35,"  2       3      4");
			printf_xy(106,70,"5");
			printf_xy(57,94," 6                     7                      8");
			printf_xy(3,3,"1: Dunite");
			printf_xy(3,11,"2: Harzburgite");
			printf_xy(3,19,"3: Lherzolite");
			printf_xy(3,27,"4: Wehrlitte");
			printf_xy(3,35,"5: Olivine Websterite");
			printf_xy(3,43,"6: Orthopyroxenite");
			printf_xy(3,51,"7: Clinopyroxenite");
			break;
		case 3:
			page[1]=2;
			printf_xy(60,3," 1       2           3           4      5");
			printf_xy(74,30,"6       7            8       9");
			printf_xy(105,75,"10");
			
			switch(page[0])
			{
				case 1:
					printf_xy(3,3,"1: Foid-Bearing ");
					printf_xy(11,11,"Alkali-spar");
					printf_xy(11,19,"Syenite");
					printf_xy(3,27,"2: Foid-Bearing ");
					printf_xy(11,35,"Syenite");
					printf_xy(3,43,"3: Foid-Bearing");
					printf_xy(11,51,"Monzonite");
					printf_xy(3,59,"4: Foid-Gearing");
					printf_xy(11,67,"Monzodiorite");
					printf_xy(3,75,"5: Foid-Bearing Diorite/");
					printf_xy(11,83,"Gabbro");
					printf_xy(3,91,"<MORE>"); 
					break;
				case 2:
					printf_xy(3,3,"<MORE>");
					printf_xy(3,11,"6: (Foid) Syenite");
					printf_xy(3,19,"7: (Foid)");
					printf_xy(11,27,"Monzosyenite");
					printf_xy(3,35,"8: (Foid)");
					printf_xy(11,43,"Monzodiorite");
					printf_xy(3,51,"9: (Foid) Gabbro");
					printf_xy(3,59,"10: (Foid)olites");
					break;
			}
			break;
		case 4:
			page[1]=1;
			printf_xy(106,4,"1");
			printf_xy(76,50,"   2         3           4");
			printf_xy(106,94,"5");
			printf_xy(3,3,"1: Anorthosite");
			printf_xy(3,11,"2: Gabbro");
			printf_xy(3,19,"3: Olivine Gabbro");
			printf_xy(3,27,"4: Troctolite");
			printf_xy(3,35,"5: Plag-Bearing");
			printf_xy(11,43,"Ultramaphics");
			break;
		case 5:
			page[1]=1;
			printf_xy(106,20,"1");
			printf_xy(75,58,"          2             3");
			printf_xy(60,88,"       3              4             5");
			printf_xy(3,3,"1: Quartz");
			printf_xy(3,11,"2: Rhyolite");
			printf_xy(3,19,"3: Dacite");
			printf_xy(3,27,"4: Trachyte");
			printf_xy(3,35,"5: Latite");
			printf_xy(3,43,"6: Andesite/Basalt");
			break;
		case 6:
			page[1]=1;
			page[1]=1;
			printf_xy(106,75,"6");
			printf_xy(75,32,"        4              5");
			printf_xy(60,3,"       1              2             3");
			printf_xy(1,3,"1: (Foid)-Bearing");
			printf_xy(9,11,"Trachyte");
			printf_xy(1,19,"2: (Foid)-Bearing");
			printf_xy(9,27,"Latite");
			printf_xy(1,35,"3: (Foid)-Bearing");
			printf_xy(9,43,"Andesite/Basalt");
			printf_xy(1,51,"4: Phonolite");
			printf_xy(1,59,"5: Tephrite");
			printf_xy(1,67,"6: (Foid)ites");
		break;
	}
	FontSetSys(F_6x8);
}

//////////////////////////////////////////////////////////////////////////////////////////////

///////////////////
// Main Function //
///////////////////

//////////////////////////////////////////////////////////////////////////////////////////////

void _main(void)
{		
	// Set Variables and Data
	
	short key=0;	
	int c=0;
	pos_set=0;chart_type=0;counter=0;named=0;undo=0;chart=0;displayed=0;data_good=0;current=1;
	type=1;change=0;move=1;last=0;modified=1;position=1;data_in=0;data_input=0;in_help=0, names_on=0;
	for(c=1;c<9;c++)
	{
		data[c]=0;
		data_undo[c]=0;	
	}	
	
	// Program Code
	
	clrscr();
	modified=1;

//////////////////////////////////////////////////////////////////////////////////////////////
// Main Program Loop //
///////////////////////
	
	// Main loop
	while(key!=KEY_ESC)
	{
		// Watch the keyboard
		key=0;
		if(kbhit())
		{
			key=ngetchx();
			if(key == KEY_RIGHT && type == 1 && names_on==0)
			{
				data_in=0;
				erase_box();
				type++;
			}
			if(key == KEY_LEFT && type == 2 && names_on==0)
			{
				data_in=0;
				erase_box();
				type--;
			}
			if(key == KEY_UP && (position > 1 || names_on==1))
			{
				if(names_on==1 && page[0]>1)
				{
					page[0]--;
					modified=1;
				}
				else if(names_on==0)
				{
					if(data_in==1)
					{
						data_in=0;
						erase_box();
						draw_cursor();
					}
					last=position;
					position--;
					move=1;
				}
			}
			if(key == KEY_DOWN && (position < 8 || names_on==1))
			{
				if(names_on==1 && page[0]<page[1])
				{
					page[0]++;
					modified=1;
				}
				else if(names_on==0)
				{
					if(data_in==1)
					{
						data_in=0;
						erase_box();
						draw_cursor();
					}
					last=position;
					position++;
					move=1;
				}								
			}
			if(key=='1'){enter_data(1);}
			if(key=='2'){enter_data(2);}
			if(key=='3'){enter_data(3);}
			if(key=='4'){enter_data(4);}
			if(key=='5'){enter_data(5);}
			if(key=='6'){enter_data(6);}
			if(key=='7'){enter_data(7);}
			if(key=='8'){enter_data(8);}
			if(key=='9'){enter_data(9);}
			if(key=='0'){enter_data(0);}
			if(key==KEY_BACKSPACE){enter_data(10);modified=1;}
			if(key==KEY_ENTER)
			{
				if(in_help==1 || displayed==1){in_help=0;displayed=0;}
				erase_box();
				clearit();
				data_in=0;
				calculate();
				modified=1;
				change=-1;
			}
			if(key==KEY_CLEAR)
			{
				for(c=1;c<9;c++)
				{
					data[c]=0;
				}
				modified=1;
				clearit();
				clearleft();
				calculate();
				names_on=0;
				change=-1;
				in_help=0;
				type=1;
			}
			if(key == KEY_F4 && data_good==1)
			{
				if(names_on==1)
				{
					clearit();
					clearleft();
					names_on=0;
				}
				else if(names_on==0)
				{
					names_on=1;
				}	
				displayed=0;
				modified=1;
				change=-1;
			}
			if(key == KEY_F5)
			{				
				if(in_help==1)
				{
					clearit();
					calculate();
					displayed=0;
					modified=1;
					change=-1;
					in_help=0;
				}
				else if(in_help==0)
				{
					clearit();
					FontSetSys(F_4x6);
					printf_xy(57,3,"Use Left and Right Arrows to");
					printf_xy(59,11,"change grain size.");
					printf_xy(57,19,"Clear resets all values and");
					printf_xy(59,27,"clears the screen.");
					printf_xy(57,35,"Enter will calculate the data");
					printf_xy(59,43,"and graph it if it is good.");
					printf_xy(57,51,"Use Up and Down Arrows to ");
					printf_xy(59,59,"select a value to change and");
					printf_xy(59,67,"press '0', backspace or a new");
					printf_xy(59,75,"number to set a new value.");
					printf_xy(57,83,"Press F4 to toggle the display");
					printf_xy(59,91,"of rock names on the chart.");
					FontSetSys(F_6x8);
					in_help=1;
				}					
			}
		}	
		
		// Keep the input box updated	
		if(data_in==1){draw_box();}
				
		// Keep type line updated
		if(change != type)
		{
			change = type;
			printf_xy(8,89,"       ");
			FontSetSys(F_4x6);
			if(type == 1){printf_xy(9,89,"Phaneritic>");}
			if(type == 2){printf_xy(9,89,"<Aphanitic");}
			FontSetSys(F_6x8);
		}		
		
		// Keep the cursor and chart updated	
		if(names_on==0){draw_cursor();}
		if(chart==0){undo=0;}
		if(chart==1 && undo==0){undo=chart_type;}	
		if(chart==1 && undo!=chart_type)
		{
			clearit();
			undo=chart_type;
			displayed=0;
			pos_set=0;
		}	
		if(data_good==1 && displayed!=1)
		{
			printf_xy(67,40,"              ");
			printf_xy(67,48,"              ");
			if(names_on==1){draw_names();}
			draw_chart();
			draw_pos();
			displayed=1;
		}
		if(data_good==0)
		{
			if(in_help==0)
			{
				FontSetSys(F_4x6);
				printf_xy(67,40,"Please enter valid data");
				printf_xy(71,48,"Or press F5 for help.");
				FontSetSys(F_6x8);
			}
			displayed=0;
		}
		
		// Keep data updated
		if(modified==1 && names_on==0)
		{
			printf_xy(25,13,"    ");
			printf_xy(25,22,"    ");
			printf_xy(25,31,"    ");
			printf_xy(25,40,"    ");
			printf_xy(25,49,"    ");
			printf_xy(25,58,"    ");
			printf_xy(25,67,"    ");
			printf_xy(25,76,"    ");	
			printf_xy(25,13,"%f",data[1]);
			printf_xy(25,22,"%f",data[2]);
			printf_xy(25,31,"%f",data[3]);
			printf_xy(25,40,"%f",data[4]);
			printf_xy(25,49,"%f",data[5]);
			printf_xy(25,58,"%f",data[6]);
			printf_xy(25,67,"%f",data[7]);
			printf_xy(25,76,"%f",data[8]);
			modified=0;
		}
		else if(modified==1 && names_on==1)
		{
			clearleft();
			draw_names();
			draw_chart();
			draw_pos();
			modified=0;
		}
		
		// Keep screen updated
		DrawLine(0,0,159,0,A_NORMAL);
		DrawLine(159,0,159,99,A_NORMAL);
		DrawLine(159,99,0,99,A_NORMAL);
		DrawLine(0,99,0,0,A_NORMAL);
		if(names_on==0)
		{	
			DrawLine(55,0,55,99,A_NORMAL);
			DrawLine(56,0,56,99,A_NORMAL);
			DrawLine(0,11,55,11,A_NORMAL);
			DrawLine(23,11,23,84,A_NORMAL);
			DrawLine(0,84,56,84,A_NORMAL);
			printf_xy(3,2,"Petrowiz");
			printf_xy(3,13,"Q");
			printf_xy(3,22,"A");
			printf_xy(3,31,"P");
			printf_xy(3,40,"F");
			printf_xy(3,49,"PYX");
			printf_xy(3,58,"OPX");
			printf_xy(3,67,"CPX");
			printf_xy(3,76,"OL");
		}		
	}	
	
	//////////////////////////////////////////////////////////////////////////////////////////////

}